clear all;
close all;

m = 1000;
eps = 0.000001;

for i = 1 : m
    m = randi(5);
    p = randi(5);
    n = randi(100);
    
    A = randn(m, n);
    A(m, 1 : n) = zeros(1, n);
    B = randn(p, n);
    B(p, 1 : n) = zeros(1, n);

    [U, V, X, C, S, Q] = my_gsvd(A, B);

    k = rank([A; B]);
    
    assert(isempty(find(C < 0)));
    %assert(isempty(find(S < 0)));
    assert(size(X, 1) == k);
    assert(size(X, 1) == size(X, 2));
    assert(size(U, 1) == m);
    assert(size(U, 2) == m);
    assert(size(V, 1) == p);
    assert(size(V, 2) == p);
    assert(size(X, 1) == size(X, 2));
    assert(size(U, 2) == size(C, 1));
    assert(size(V, 2) == size(S, 1));
    assert(size(C, 2) == size(X, 1));
    assert(size(S, 2) == size(X, 1));
    assert(size(Q, 1) == n);
    assert(size(Q, 2) == n);
    assert(norm(U' * U - eye(m)) < eps);
    assert(norm(V' * V - eye(p)) < eps);
    assert(norm(C' * C + S' * S - eye(k)) < eps);
    assert(norm(Q' * Q - eye(n)) < eps);

    AC = U * C * [X, zeros(k, n - k)] * Q';
    BC = V * S * [X, zeros(k, n - k)] * Q';

    assert(norm(AC - A) < eps);
    assert(norm(BC - B) < eps);
end
